# coding:utf-8
from IndexItem import IndexItem
from IndexComputerFile import IndexComputer
import json,redis,datetime,pymysql,os

env_dist = os.environ           #获取环境变量
FK_DB_HOST = env_dist.get('FK_DB_HOST')      #获取mysql地址
FK_DB_PORT = env_dist.get('FK_DB_PORT')      #获取mysql端口号
FK_DB_USER = env_dist.get('FK_DB_USER')      #获取mysql用户名
FK_DB_PWD = env_dist.get('FK_DB_PWD')      #获取mysql密码
FK_DB_NAME = env_dist.get('FK_DB_NAME')   #获取mysql库

class RiskComputer:
    IndexRes={}
    IndexRes1={}
    indexs=[]
    RCFactorsValue={}
    def IndexsGet(self,indexs):
        self.indexs=indexs
    def FactorGet(self,factors):
        self.RCFactorsValue=factors
    def Compute(self,Previous_Date):#计算所有指标
        Curr_Date = Previous_Date['Curr_Date']
        Previous_Date = Previous_Date['Previous_Date']
        for indexItem in self.indexs:
            factors=indexItem.Factors.split(":")
            flag=True
            indexItem.FactorsValue={}
            for factor in factors:
                if factor in self.RCFactorsValue:
                    indexItem.FactorsValue[factor]=self.RCFactorsValue[factor]
                else:
                    flag=False
                    break
            ic=IndexComputer()
            if indexItem.Category == 'tax_risk':
                if flag:
                    ret=ic.Compute(indexItem)
                    self.IndexRes[indexItem.Name]=ret
                else:
                    self.IndexRes[indexItem.Name]="0"
            else:
                if flag:
                    ret = ic.finance_Compute(indexItem)
                else:
                    ret = "—"
                a=indexItem.Name
                if(a not in self.IndexRes1):
                    self.IndexRes1[a]={Curr_Date:ret}
                else:
                    if(Previous_Date not in self.IndexRes1[a]):
                        self.IndexRes1[a][Previous_Date]=ret
                    else:
                        self.IndexRes1[a]["change_rate"]=ret
    def Ret2Json(self):#把指标结果转化为樊辉需要的Json
        #json写入数据库
        # db = pymysql.connect(host='47.105.186.2',port=3307,user='caishui',password='jvmfTVDuG5YE(*Z',db='fktaxctl',charset="utf8mb4")
        db = pymysql.connect(host=FK_DB_HOST,port=int(FK_DB_PORT),user=FK_DB_USER,password=FK_DB_PWD,db=FK_DB_NAME,charset="utf8mb4")
        cursor = db.cursor()  
        arr = [self.IndexRes,self.IndexRes1]
        ss = ['ri','fi']
        for i,index_results in enumerate(arr): #索引，值
            print(i,"=============i")
            print(index_results, "=============qq")
            for key in index_results:
                # print(self.indexs['id'],"=======公式id")
                #'factors_name':'指标状态'
                ri1 = {}
                ri1[key]= index_results[key]
                insert_batch_No = "'"+str(self.batch_No)+"'"
                fi_dict={"营业总收入":"Total_trade_income","利润总额":"Total_profit","净利润":"Net_profit","负债总额":"Total_Liabilities","所有人权益":"Owner_rights","销售总额":"Total_sales",
                         "资产总额":"Total_assets","负债及所有者权益合计":"Total_liabilities_and_Owner_rights","销售费用":"sales_expense","销售净利率":"Net_interest_rate","产权比率":"Equity_ratio",
                         "销售增长率":"sales_growth_rate","净利润增长率":"Net_profit_growth_rate","资产负债比率":"Gearing_ratio","总资产增长率":"total_assets_growth_rate"
                         }
                if key in fi_dict:
                    insert_key = str(fi_dict[key])
                else:
                    insert_key = str(key)
                insert_status = str(index_results[key])
                sql='INSERT INTO result_set(Batchno,indexName,status,biztype) VALUES (%s,"%s","%s","%s")'%(insert_batch_No,insert_key,insert_status,ss[i])
                # print(sql,"======风控sql")
                try:
                    cursor.execute(sql)
                # 提交到数据库执行
                    db.commit()
                except Exception as e:
                    print(e)
                    db.rollback()
            # 关闭数据库连接
        db.close()
        jsonStr=json.dumps(self.IndexRes1,ensure_ascii=False, indent=4, separators=(',', ':'))
        return jsonStr