#!/usr/bin/env python
# -*- coding: utf-8 -*-
# @Time    : 2020/1/1 0001 下午 3:31
# @Author  : hj
# @File    : getInfoByBatchNo.py
# @Software: PyCharm
import requests,json,redis,re,os
from RiskComputer import RiskComputer  #计算并将结果写入mysql数据库
from IndexGet import IndexGet
from Update import UpdateId

env_dist = os.environ           #获取环境变量
FK_REDIS_HOST = env_dist.get('FK_REDIS_HOST')   #获取redis地址
FK_REDIS_PORT = env_dist.get('FK_REDIS_PORT')   #获取redis端口号
FK_REDIS_PWD = env_dist.get('FK_REDIS_PWD')   #获取redis密码
FK_REDIS_DB = env_dist.get('FK_REDIS_DB')   #获取redis库

print(FK_REDIS_HOST)
print(FK_REDIS_PORT)
print(FK_REDIS_PWD)
print(FK_REDIS_DB)

#使用任务号获取任务信息
def getInfo_ByBatchNo(BatchNo):
    Info_task=[]
    url = 'https://risk-api.gongsibao.com/risk-api/getInfoByBatchNo'    #获取信息接口
    name = {"batchCode":BatchNo}  # 根据任务号进行接口访问参数
    taskInfo = requests.get(url,name) # 访问接口返回的信息
    taskInfo_New = json.loads(taskInfo.text)
    # print("任务信息获取：",taskInfo_New,BatchNo)
    if taskInfo_New['data'] is None:
        print("taskInfo_New['data'] is None")
        # client.rpop('notifyRule')
        quit()
    Info_Task = taskInfo_New['data']
    AccountInfo = {}
    AccountInfo["taxCode"]=Info_Task['taxCode']   # 获取纳税人识别号
    AccountInfo["batchCode"]=Info_Task['batchCode']   # 获取批次号
    AccountInfo["timeType"] = Info_Task['timeType']   # 获取时间类型
    AccountInfo["timeGet"] = Info_Task['timeGet']  # 获取当期时间
    if Info_Task["timeType"] =="Y":
        currentIssue = Info_Task["checkYear"]
    elif Info_Task["timeType"] =="Q":
        currentIssue = Info_Task["checkQuarter"]
    else:currentIssue = Info_Task["checkMonth"]
    AccountInfo["currentIssue"]=currentIssue
    Info_task.append(AccountInfo)
    print("返回任务信息")
    return Info_task
# 任务信息: [{'taxCode': '123456', 'batchCode': '51', 'timeType': 'Y', 'currentIssue': '2019'}]

#获取自定义的期数
def customBatch(custom_currentIssue,offset,timeType):
    url = 'https://risk-api.gongsibao.com/risk-api/getIssueByCustomer'    #获取信息接口
    name = {"currentIssue":custom_currentIssue,"offset":offset,"timeType":timeType}  # 接口访问参数
    batchInfo = requests.post(url,name) # 访问接口返回的信息
    batchInfo_New = json.loads(batchInfo.text)
    currentIssue = batchInfo_New['data']
    # print("接口计算的期数为：",currentIssue)
    return currentIssue

#获取L期数信息
def Transformer(currentYear,YearyearInfo,issueNum):
    if  "L" in YearyearInfo:
        year=currentYear-1
    else:
        year=currentYear
    if "Q" in YearyearInfo:
        issueNumTemp=int(issueNum)*3
        issueNumStr=str(issueNumTemp)
        if(len(str(issueNumTemp)))<2:
            issueNumStr="0"+str(issueNumTemp)
        currentIssue=str(year)+issueNumStr
    else:
        if(len(issueNum))<2:
            issueNum="0"+str(issueNum)
        currentIssue=str(year)+str(issueNum)
    # print("自己计算期数为：",currentIssue)
    return currentIssue

# 调用映射接口，转化为位置编码
def posmap(talbe,cellPos):
    talbe = str(talbe)
    cellPos = str(cellPos)
    url = 'https://fkctlapi.gongsibao.com/api/rpt/rptApi/queryPosMap'
    positionInfo = requests.post(url)
    positionInfo_New = json.loads(positionInfo.text)
    if positionInfo_New['status'] == 0:
        posmap_result = {}
        posmap_lists = positionInfo_New['data']['data']
        for posmap_list in posmap_lists: #cellPos:坐标值；cellDesc:单元格中文编码
            if (posmap_list["rpttypecode"] == talbe and posmap_list["nposition"] == cellPos):
                posmap_result['cellDesc'] = posmap_list["position"]
                posmap_result['cellPos'] = ""
                # print(posmap_result['cellDesc'],"===============因子中文编码位置")
            else:
                posmap_result['cellDesc'] = ""
                posmap_result['cellPos'] = cellPos
    else:
        posmap_result = '因子中文编码查询错误'
    return posmap_result

#获取本期指定报表的单元格值
def getValue(batchCode,cellDesc,cellPos,currentIssue,fileCode,taxCode,timeType):
    batchCode = str(batchCode)
    cellDesc =str(cellDesc)
    cellPos = str(cellPos)
    currentIssue =str(currentIssue)
    fileCode = str(fileCode)
    taxCode = str(taxCode)
    timeType =str(timeType)
    url = 'https://risk-api.gongsibao.com/risk-api/getCellValuesByIssue'    #获取信息接口
    if cellDesc == "":
        name = {"batchCode":batchCode,"cellPos":cellPos,"currentIssue":currentIssue,"fileCode":fileCode,"taxCode":taxCode,"timeType":timeType}  # 接口访问参数
    else:
        name = {"batchCode":batchCode,"cellDesc":cellDesc,"currentIssue":currentIssue,"fileCode":fileCode,"taxCode":taxCode,"timeType":timeType}  # 接口访问参数
    contentInfo = requests.post(url,name) # 访问接口返回的信息
    batchInfo_New = json.loads(contentInfo.text)
    index_Values = batchInfo_New['data']
    if index_Values is None:
        index_Value =0 #"缺少数据"
    else:
        index = index_Values[0]
        index_Value = index["cellContent"]
    # print("单元格数据为：",index_Value)
    return index_Value

def fun(str):
    fun_list=[]
    indexdict={}
    if len(str.split("_")[3])<=2 :
        str=str+'0'
    table=str.split("_")[0]
    row=str.split("_")[1]
    cloumn=str.split("_")[2]
    coordinate = row+"-"+cloumn
    times=str.split("_")[3]
    nums=re.findall(r'([A-Z]+)([0-9]+)',times)[0][1]
    indexdict["table"]=table
    indexdict["row"] = row
    indexdict["cloumn"]= cloumn
    indexdict["position"] = coordinate
    indexdict["times"] = times
    indexdict["nums"] = "-"+nums
    indexdict["issueNum"] = nums
    fun_list.append(indexdict)
    return fun_list


def Previous(tasks):
    global Previous_month, Previous_Date
    Date_Info={}
    Curr_Get = tasks['timeGet']
    Curr_year = Curr_Get[0:4]
    Curr_month = Curr_Get[4:7]
    Curr_Date = Curr_year + '-' + Curr_month
    print(Curr_month, "=================Curr_month")
    #转化当前时间
    if Curr_month in ("01", "03", "05", "07", "08", "10", "12"):
        Curr_Day = "31"
    elif Curr_month in ("04", "06", "09", "11"):
        Curr_Day = "30"
    else:
        if Curr_year % 4 == 0 and Curr_year % 400 == 0:
            Curr_Day = "29"
        elif Curr_year % 4 == 0 and Curr_year % 100 != 0:
            Curr_Day = "29"
        else:
            Curr_Day = "28"
    Curr_Date = Curr_Date+'-'+Curr_Day
    #打印出上一期时间
    if tasks["timeType"] == "Y":
        Previous_year = int(Curr_year)-1
        Previous_Date = str(Previous_year)+"-"+Curr_month
    elif tasks["timeType"] == "Q":
        if int(Curr_month)<= 3 :
            Previous_year = int(Curr_year) - 1
            Previous_month = 12
        else:
            Previous_year = Curr_year
            str_month = str(int(Curr_month)-3)
            if len(str_month)>2:
                Previous_month = int(Curr_month)-3
            else:
                Previous_month = "0"+str_month
        Previous_Date = str(Previous_year)+ '-' +str(Previous_month)
    else:
        if int(Curr_month) == 1:
            Previous_year = int(Curr_year) - 1
            Previous_month = 12
        else:
            Previous_year = Curr_year
            str_month = str(int(Curr_month) - 1)
            if len(str_month)>2:
                Previous_month = str_month
            else:
                Previous_month = "0"+str_month
            Previous_Date = str(Previous_year) + '-' + str(Previous_month)
    if Previous_month in ("01", "03", "05", "07", "08", "10", "12"):
        Previous_Day = "31"
    elif Previous_month in ("04", "06", "09", "11"):
        Previous_Day = "30"
    else:
        if Previous_year % 4 == 0 and Previous_year % 400 == 0:
            Previous_Day = "29"
        elif Previous_year % 4 == 0 and Previous_year % 100 != 0:
            Previous_Day = "29"
        else:
            Previous_Day = "28"
    Previous_Date = Previous_Date + '-' + Previous_Day
    Date_Info["Curr_Date"] = Curr_Date
    Date_Info["Previous_Date"] = Previous_Date
    return Date_Info


def report(BatchNo):
    print(BatchNo,"=============触发生成报告接口")
    url = 'https://fkctlapi.gongsibao.com/api/rpt/rptApi/buildWordReport'

    name = {"batchid": BatchNo}
    reportInfo = requests.post(url,name)
    reportInfo_New = json.loads(reportInfo.text)
    print(reportInfo_New, "reportInfo_New")
    if reportInfo_New['status'] == 0:
        report_result = '触发生成报告接口成功'
    else:
        report_result = '触发生成报告接口失败'
    return report_result

redisPool = redis.ConnectionPool(host=FK_REDIS_HOST, port=int(FK_REDIS_PORT), password=FK_REDIS_PWD,db=FK_REDIS_DB)
client = redis.Redis(connection_pool=redisPool)
a = client.lrange('notifyRule',-1,-1)
print(a,"aaa")
if len(a)==0:
    print("notifyRule数据为空")
    quit()
value =a[-1]
if client is None:
    client.rpop('notifyRule')
    quit()
if value is None:
    client.rpop('notifyRule')
    quit()
result=json.loads(value)
print(result,"result")
content=result["content"]
print(content,"content")
taxTypeCode=content["taxTypeCode"]#企业性质
accountTypeCode=content["accountTypeCode"]#会计准则
# accountTypeCode="S"#会计准则
BatchNo=content["batchCode"]
# BatchNo=226
# taxTypeCode = "ST"
if taxTypeCode=="ST":
    taxTypeCode="S"
else:
    taxTypeCode="G"
type=taxTypeCode+"-"+accountTypeCode
indexsGet=IndexGet()#获取所有指标信息
#根据任务号获取任务信息
Info_task=getInfo_ByBatchNo(BatchNo)
tasks=Info_task[0]
Previous_Date=Previous(tasks)
indexs=indexsGet.Subscribe(tasks['timeType'],type)#根据时间类型和企业类型获取特征s
print(tasks['timeType'],type,"==============获取查询公式条件")
# indexs=indexsGet.Subscribe('Q','G-N')#根据时间类型和企业类型获取特征
factors={}
for indexItem in indexs:
    factorsStr=indexItem.Factors
    factorsGrp=factorsStr.replace("：",":").split(":")
    for factorItem in factorsGrp:
        if factorItem not in factors and len(factorItem.lstrip().rstrip())>0:
            factors[factorItem]=0.0

factorsnew={}
for factor in factors:#获取所有因子
    fun_list=fun(str(factor))
    index = fun_list[0]
    cellPos=index['position']
    talbe = index['table']
    batchCode = BatchNo
    posmap_result=posmap(talbe,cellPos)
    position_data = posmap_result['cellPos']
    cellDesc = posmap_result['cellDesc']
    offset = index['nums']
    times = index['times']
    issueNum = index['issueNum']
    YearyearInfo = times[0:2]
    currentIssue = tasks["currentIssue"]
    fileCode = index['table']
    taxCode = tasks["taxCode"]
    timeType = tasks["timeType"]
    currentYear = int(currentIssue[0:4])
    # 获取L期数信息
    if "L" in YearyearInfo:
        Info_LBatch = Transformer(currentYear, YearyearInfo, issueNum)
    else:
         # 获取自定义期数
        Info_LBatch=customBatch(currentIssue,offset,timeType)
    # 获取单元格值
    index_Value = getValue(batchCode,cellDesc,cellPos,currentIssue,fileCode,taxCode,timeType)
    factorsnew[factor] = index_Value

factors=factorsnew
rc=RiskComputer() #构建指标计算对象
rc.batch_No = BatchNo
rc.indexs = indexs
rc.FactorGet(factors)#把因子装入对象
rc.IndexsGet(indexs)#把指标装入对象
rc.Compute(Previous_Date)#指标计算
jsonstr = rc.Ret2Json()#指标输出成樊辉要的格式
report_result = report(BatchNo)    #触发生成报告接口
print(jsonstr)
client.rpop('notifyRule')
Updqtestatus=UpdateId()
Updqtestatus.Update(batchCode)
print(batchCode,"batchCode")
print("消耗结束")